#ifndef IRQ_H
#define IRQ_H
#ifdef __cplusplus
extern "C" {
#endif


#include "lib/gba.h"

//---------------------------------------------------------------------------
#define IRQ_SERIAL_CMD_START 0x00010000
#define IRQ_SERIAL_CMD_END   0x00020000


//---------------------------------------------------------------------------
typedef struct {
	bool isUse;
	u32  buf[64];
	s32  cntStack;
	s32  cntSend;

} ST_IRQ;

//---------------------------------------------------------------------------
EWRAM_CODE void IrqInit(void);

IWRAM_CODE void IrqHandler(void);
IWRAM_CODE void IrqHandlerSerial(void);
IWRAM_CODE void IrqHandlerVblank(void);

IWRAM_CODE void IrqSerialAdd(u32 d);
IWRAM_CODE void IrqSerialAddCmdStart(void);
IWRAM_CODE void IrqSerialAddCmdEnd(void);
IWRAM_CODE void IrqSerialReady(void);
IWRAM_CODE bool IrqSerialIsUse(void);


#ifdef __cplusplus
}
#endif
#endif
